package buildcraft.builders;

import net.minecraft.init.Items;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;

import buildcraft.api.library.LibraryTypeHandlerNBT;
import buildcraft.core.lib.utils.NBTUtils;

public class LibraryBookTypeHandler extends LibraryTypeHandlerNBT {
    public LibraryBookTypeHandler() {
        super("book");
    }

    @Override
    public boolean isHandler(ItemStack stack, HandlerType type) {
        if (type == HandlerType.STORE) {
            return stack.func_77973_b() == Items.field_151164_bB;
        } else {
            return stack.func_77973_b() == Items.field_151099_bA || stack.func_77973_b() == Items.field_151164_bB;
        }
    }

    @Override
    public int getTextColor() {
        return 0x684804;
    }

    @Override
    public String getName(ItemStack stack) {
        String s = NBTUtils.getItemData(stack).func_74779_i("title");
        return s != null ? s : "";
    }

    @Override
    public ItemStack load(ItemStack stack, NBTTagCompound compound) {
        ItemStack out = new ItemStack(Items.field_151164_bB);
        NBTTagCompound outNBT = new NBTTagCompound();
        outNBT.func_74778_a("title", compound.func_74779_i("title"));
        outNBT.func_74778_a("author", compound.func_74779_i("author"));
        outNBT.func_74782_a("pages", compound.func_150295_c("pages", 8));
        out.func_77982_d(outNBT);
        return out;
    }

    @Override
    public boolean store(ItemStack stack, NBTTagCompound compound) {
        NBTTagCompound inNBT = NBTUtils.getItemData(stack);
        compound.func_74778_a("title", inNBT.func_74779_i("title"));
        compound.func_74778_a("author", inNBT.func_74779_i("author"));
        compound.func_74782_a("pages", inNBT.func_150295_c("pages", 8));
        return true;
    }
}
