package buildcraft.silicon;

import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.projectile.EntityThrowable;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.DamageSource;
import net.minecraft.util.MovingObjectPosition;
import net.minecraft.world.World;

import buildcraft.BuildCraftSilicon;

public class EntityPackage extends EntityThrowable {
    private ItemStack pkg;

    public EntityPackage(World world) {
        super(world);
        this.pkg = new ItemStack(BuildCraftSilicon.packageItem);
    }

    public EntityPackage(World world, EntityPlayer player, ItemStack stack) {
        super(world, player);
        this.pkg = stack;
    }

    public EntityPackage(World world, double x, double y, double z, ItemStack stack) {
        super(world, x, y, z);
        this.pkg = stack;
    }

    @Override
    public void func_70109_d(NBTTagCompound compound) {
        super.func_70109_d(compound);
        NBTTagCompound subTag = new NBTTagCompound();
        pkg.func_77955_b(subTag);
        compound.func_74782_a("stack", subTag);
    }

    @Override
    public void func_70020_e(NBTTagCompound compound) {
        super.func_70020_e(compound);
        if (compound.func_74764_b("stack")) {
            pkg = ItemStack.func_77949_a(compound.func_74775_l("stack"));
        }
    }

    @Override
    protected void func_70184_a(MovingObjectPosition target) {
        double x, y, z;
        if (target.field_72313_a == MovingObjectPosition.MovingObjectType.ENTITY) {
            x = target.field_72308_g.field_70165_t;
            y = target.field_72308_g.field_70163_u;
            z = target.field_72308_g.field_70161_v;
        } else {
            x = target.func_178782_a().func_177958_n();
            y = target.func_178782_a().func_177956_o();
            z = target.func_178782_a().func_177952_p();
        }

        float hitPoints = 0.0F;
        for (int i = 0; i < 9; i++) {
            ItemStack stack = ItemPackage.getStack(pkg, i);
            if (stack != null) {
                if (stack.func_77973_b() instanceof ItemBlock) {
                    hitPoints += 0.28F;
                } else {
                    hitPoints += 0.14F;
                }
                float var = 0.7F;
                World world = this.field_70170_p;
                double dx = world.field_73012_v.nextFloat() * var + (1.0F - var) * 0.5D;
                double dy = world.field_73012_v.nextFloat() * var + (1.0F - var) * 0.5D;
                double dz = world.field_73012_v.nextFloat() * var + (1.0F - var) * 0.5D;
                EntityItem entityitem = new EntityItem(world, x + dx, y + dy, z + dz, stack);
                entityitem.func_174869_p();

                world.func_72838_d(entityitem);
            }
        }

        if (target.field_72313_a == MovingObjectPosition.MovingObjectType.ENTITY) {
            target.field_72308_g.func_70097_a(DamageSource.func_76356_a(this, this), hitPoints);
        }

        func_70106_y();
    }
}
