/** Copyright (c) 2011-2015, SpaceToad and the BuildCraft Team http://www.mod-buildcraft.com
 * <p/>
 * BuildCraft is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL. Please check the contents
 * of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt */
package buildcraft.silicon.gui;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.entity.player.InventoryPlayer;
import net.minecraft.inventory.Slot;
import net.minecraft.item.ItemStack;

import buildcraft.core.lib.gui.BuildCraftContainer;
import buildcraft.core.lib.gui.slots.SlotOutput;
import buildcraft.core.lib.gui.slots.SlotValidated;
import buildcraft.silicon.TilePackager;

public class ContainerPackager extends BuildCraftContainer {
    private final TilePackager tile;

    public ContainerPackager(EntityPlayer player, TilePackager t) {
        super(player, t.func_70302_i_());

        this.tile = t;

        // sort in order of shift-click!

        func_75146_a(new SlotValidated(tile, 9, 124, 7));

        for (int x = 0; x < 9; x++) {
            func_75146_a(new Slot(tile, x, 8 + x * 18, 84));
        }

        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 3; x++) {
                func_75146_a(new SlotPackager(tile.inventoryPattern, x + y * 3, 30 + x * 18, 17 + y * 18));
            }
        }

        // addSlotToContainer(new Slot(tile, 10, 108, 31));
        func_75146_a(new SlotOutput(tile, 11, 123, 59));

        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 9; x++) {
                func_75146_a(new Slot(player.field_71071_by, x + y * 9 + 9, 8 + x * 18, 115 + y * 18));
            }
        }

        for (int x = 0; x < 9; x++) {
            func_75146_a(new Slot(player.field_71071_by, x, 8 + x * 18, 173));
        }

        func_75130_a(tile);
    }

    @Override
    public ItemStack func_75144_a(int slotNum, int mouseButton, int modifier, EntityPlayer player) {
        Slot slot = slotNum < 0 ? null : (Slot) this.field_75151_b.get(slotNum);
        ItemStack out = super.func_75144_a(slotNum, mouseButton, slot instanceof SlotPackager ? 0 : modifier, player);

        if (slot instanceof SlotPackager) {
            int idx = slot.getSlotIndex();
            ItemStack stack = player != null && player.field_71071_by != null ? player.field_71071_by.func_70445_o() : null;
            if (stack == null) {
                tile.setPatternSlot(idx, !tile.isPatternSlotSet(idx));
            } else {
                tile.setPatternSlot(idx, true);
            }
            tile.sendNetworkUpdate();
        }
        return out;
    }

    @Override
    public boolean func_75145_c(EntityPlayer entityplayer) {
        return tile.func_70300_a(entityplayer);
    }
}
