/** Copyright (c) 2011-2015, SpaceToad and the BuildCraft Team http://www.mod-buildcraft.com
 * <p/>
 * BuildCraft is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL. Please check the contents
 * of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt */
package buildcraft.silicon.gui;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.ICrafting;
import net.minecraft.inventory.Slot;

import buildcraft.core.lib.gui.BuildCraftContainer;
import buildcraft.core.lib.gui.slots.SlotOutput;
import buildcraft.core.lib.gui.slots.SlotValidated;
import buildcraft.silicon.TileStampingTable;

public class ContainerStampingTable extends BuildCraftContainer {

    private TileStampingTable table;

    public ContainerStampingTable(EntityPlayer player, TileStampingTable table) {
        super(player, table.func_70302_i_());
        this.table = table;

        addSlot(new SlotValidated(table, 0, 15, 18));
        addSlot(new SlotOutput(table, 1, 143, 18));
        addSlot(new SlotOutput(table, 2, 111, 45));
        addSlot(new SlotOutput(table, 3, 129, 45));
        addSlot(new SlotOutput(table, 4, 147, 45));

        for (int y = 0; y < 3; y++) {
            for (int x = 0; x < 9; x++) {
                func_75146_a(new Slot(player.field_71071_by, x + y * 9 + 9, 8 + x * 18, 69 + y * 18));
            }
        }

        for (int x = 0; x < 9; x++) {
            func_75146_a(new Slot(player.field_71071_by, x, 8 + x * 18, 127));
        }
    }

    @Override
    public boolean func_75145_c(EntityPlayer var1) {
        return table.func_70300_a(var1);
    }

    @Override
    public void func_75142_b() {
        super.func_75142_b();
        for (Object crafter : field_75149_d) {
            table.sendGUINetworkData(this, (ICrafting) crafter);
        }
    }

    @Override
    public void func_75137_b(int par1, int par2) {
        table.getGUINetworkData(par1, par2);
    }
}
