/** Copyright (c) 2011-2015, SpaceToad and the BuildCraft Team http://www.mod-buildcraft.com
 * <p/>
 * BuildCraft is distributed under the terms of the Minecraft Mod Public License 1.0, or MMPL. Please check the contents
 * of the license located in http://www.mod-buildcraft.com/MMPL-1.0.txt */
package buildcraft.silicon.gui;

import org.lwjgl.opengl.GL11;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.util.ResourceLocation;

import buildcraft.silicon.TileStampingTable;

public class GuiStampingTable extends GuiLaserTable {

    public static final ResourceLocation TEXTURE = new ResourceLocation("buildcraftsilicon:textures/gui/stamper.png");
    private static final int FLASH_DELAY = 3;
    private final TileStampingTable integrationTable;
    private boolean flash;
    private int flashDelay;

    public GuiStampingTable(EntityPlayer player, TileStampingTable table) {
        super(player, new ContainerStampingTable(player, table), table, TEXTURE);
        this.integrationTable = table;
        field_146999_f = 176;
        field_147000_g = 151;
    }

    @Override
    public void func_73876_c() {
        super.func_73876_c();

        if (flashDelay <= 0) {
            flashDelay = FLASH_DELAY;
            flash = !flash;
        } else {
            flashDelay--;
        }
    }

    @Override
    protected void func_146979_b(int par1, int par2) {
        drawLedgers(par1, par2);

        String title = table.getInventoryName();
        field_146289_q.func_78276_b(title, getCenteredOffset(title), 5, 0x404040);
    }

    @Override
    protected void func_146976_a(float f, int mouseX, int mouseY) {
        super.func_146976_a(f, mouseX, mouseY);
        GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
        field_146297_k.field_71446_o.func_110577_a(TEXTURE);
        if (integrationTable.getEnergy() > 0) {
            int progress = integrationTable.getProgressScaled(98);
            func_73729_b(field_147003_i + 36, field_147009_r + 14, 0, flash ? 197 : 221, progress, 24);
        }
    }
}
