package buildcraft.silicon.render;

import org.lwjgl.opengl.GL11;

import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.renderer.entity.RenderItem;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.ResourceLocation;

import buildcraft.core.lib.utils.NBTUtils;

public class PackageFontRenderer extends FontRenderer {
    private static final RenderItem itemRender = Minecraft.func_71410_x().func_175599_af();
    private static final Minecraft mc = Minecraft.func_71410_x();
    private static final FontRenderer realRenderer = mc.field_71466_p;
    private final NBTTagCompound pkgTag;

    public PackageFontRenderer(ItemStack packageStack) {
        super(mc.field_71474_y, new ResourceLocation("textures/font/ascii.png"), mc.func_110434_K(), mc.field_71466_p.func_82883_a());
        this.pkgTag = NBTUtils.getItemData(packageStack);
    }

    @Override
    public int func_78256_a(String s) {
        if (!s.contains("SPECIAL:")) {
            return realRenderer.func_78256_a(s);
        }

        return 21;
    }

    // TODO: Bug-test!
    @Override
    public int func_175065_a(String s, float x, float y, int color, boolean shadow) {
        if (!s.contains("SPECIAL:")) {
            return realRenderer.func_175065_a(s, x, y, color, shadow);
        }

        int begin = Integer.parseInt(s.substring(s.length() - 1)) * 3;
        int rx = (int) x;

        for (int slotPos = begin; slotPos < begin + 3; slotPos++) {
            GL11.glPushMatrix();

            if (pkgTag.func_74764_b("item" + slotPos)) {
                ItemStack slotStack = ItemStack.func_77949_a(pkgTag.func_74775_l("item" + slotPos));
                if (slotStack != null) {
                    GL11.glTranslatef(0.0F, 0.0F, 32.0F);
                    GL11.glScalef(0.5F, 0.5F, 0.5F);
                    FontRenderer font = slotStack.func_77973_b().getFontRenderer(slotStack);
                    itemRender.field_77023_b = 200.0F;

                    if (font == null || font instanceof PackageFontRenderer) {
                        font = Minecraft.func_71410_x().field_71466_p;
                    }

                    itemRender.func_180450_b(slotStack, rx * 2, (int) (y * 2));
                    itemRender.func_175030_a(font, slotStack, rx * 2, (int) (y * 2));
                    itemRender.field_77023_b = 0.0F;
                } else {
                    realRenderer.func_175063_a("X", rx, y, 0xFF0000);
                }
            }

            rx += 7;

            GL11.glPopMatrix();
        }
        return rx;
    }
}
